 /*
 * file      : translate.c
 * project   : xcfa
 * with      : Gtk-2
 *
 * copyright : (C) 2003 - 2010 by Claude Bulin
 *
 * xcfa - GTK+ implementation of the GNU shell command
 * GNU General Public License
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * OLD ADRESS:
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * NEW ADRESS:
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 * 
 */
 
 
#ifdef HAVE_CONFIG_H
	#include <config.h>
#endif

#ifdef ENABLE_NLS
	#include <libintl.h>
	#define _(String) gettext (String)
#endif

#include <gtk/gtk.h>
#include <string.h>

#ifdef ENABLE_STATIC_LIBRARY
	#include "../lib/lib.h"
#endif

#include "global.h"



void translate_xcfa (void)
{
	typedef struct {
		gchar	*string;
	} TRANS;
TRANS trans[] = {

{ _("Fichier") },
{ _("Quitter") },
{ _("Outils") },
{ _("Visibilite des champs") },
{ _("Aide") },
{ _("A propos") },
{ _("Lecture") },
{ _(" <b>Choix du peripherique / Lecture du DVD</b> ") },
{ _("<b> Destination des fichiers </b>") },
{ _("<b> Eject </b>") },
{ _("<b> Normaliser </b>") },
{ _("Deplier") },
{ _("Replier") },
{ _("<b> Vers 2CH: Sub / Ambiance </b>") },
{ _("Extraire") },
{ _(" DVD ") },
{ _("Lecture") },
{ _(" <b>Choix du peripherique / Lecture du CD</b> ") },
{ _("<b> Destination des fichiers </b>") },
{ _("<b> Eject </b>") },
{ _("<i>Commentaire:</i>") },
{ _(" <i>*.m3u et xspf:</i> ") },
{ _(" <i>Piste:</i>") },
{ _(" <i>Genre:</i>") },
{ _(" <i>Annee:</i>") },
{ _("<i>Artiste:</i>") },
{ _("<i>Album:</i>") },
{ _("<i>Titre:</i>") },
{ _(" Modification des tags Freedb ") },
{ _("<b>%a</b>  -  artiste                                   <b>%b</b>  -  titre de l'album        <b>%c</b>  -  numero de la piste\n<b>%d</b>  -  titre de la chanson                <b>%e</b>  -  annee                     <b>%g</b>  -  genre\n<b>%f</b>   -  creation d'un fichier *.m3u et *.xspf\n<b>%u</b>  -  remplacement de caracteres: <b>%u(AB=C) %u( =_)</b>") },
{ _(" Arrangement des titres du CD ") },
{ _("Creation d'un fichier unique au format:  ") },
{ _("     et dont le nom sera:  ") },
{ _("Ecriture du fichier cue") },
{ _("<b> Au moins deux selections colonne Wav </b>") },
{ _("Creation d'un fichier cue\nunique depuis une lecture\ndu cd audio") },
{ _("Creation fichier cue uniquement") },
{ _("<b> Creation Cue cd </b>") },
{ _(" Creation d'un fichier unique ") },
{ _("<b>Gestion des tags, titres et fichiers cue</b>") },
{ _("<b> Normaliser </b>") },
{ _("<b> Serveurs </b>") },
{ _("Extraire") },
{ _(" CD ") },
{ _("<b> Importer </b>") },
{ _("<b> Destination des conversions </b>") },
{ _("<b> Nettoyer </b>") },
{ _("Ajouter le dernier dossier d'import a la destination") },
{ _("Appliquer les modifications") },
{ _("<b> Normalise: </b>") },
{ _("<b> Choix niveau dBFS: </b>") },
{ _(" Fichiers ") },
{ _("<b> Frequence - Hertz </b>") },
{ _("<b>Voie</b>") },
{ _("<b>Quantification</b>") },
{ _("Appliquer les modifications") },
{ _(" Wav ") },
{ _(" <b> Lame (fichier mp3): </b> ") },
{ _("<b> Oggenc  (fichier ogg): </b> ") },
{ _("Appliquer") },
{ _("Effacer") },
{ _(" Mp3-Ogg ") },
{ _("<b>0</b>") },
{ _("Appliquer") },
{ _(" Modif.:") },
{ _(" Piste:") },
{ _(" Genre:") },
{ _(" Annee:") },
{ _("Commentaire:") },
{ _("Artiste:") },
{ _("Album:") },
{ _("Titre:") },
{ _(" Tags ") },
{ _(" Fichiers ") },
{ _("<b> Importer </b>") },
{ _("<b> Destination des fichiers </b>") },
{ _("Lecture de 5 secondes apres le marqueur de debut") },
{ _("Index de debut") },
{ _("00h00m00s") },
{ _("lecture") },
{ _("Pause") },
{ _("Index de lecture") },
{ _("label") },
{ _("Lecture de 5 secondes apres le marqueur de fin") },
{ _("Index de fin") },
{ _("00h00m00s") },
{ _("Plage") },
{ _("Duree de la plage active") },
{ _("00h00m00s") },
{ _("Suprimer tous les marqueurs pour les remplacer par un marqueur unique") },
{ _("Le fichier CUE sera enregistre vers 'Destination des fichiers'.") },
{ _("Production fichier Cue") },
{ _("Le resultat du Split sera dirige vers 'Destination des fichiers'.") },
{ _("Split") },
{ _(" Split ") },
{ _("Recto") },
{ _("Verso") },
{ _("Effacer") },
{ _("<b> Choix images </b>") },
{ _("<b>label</b>") },
{ _("<b> Voir / Avec </b>") },
{ _("<b> Chemin et generation  PostScript / pdf </b>") },
{ _("<b> Titre du CD </b>") },
{ _("Recupere depuis le web des images selon le critere indique depuis 'Titre du CD'. Le stockage se fait dans 'Emplacement des images Web'") },
{ _("<b> Web </b>") },
{ _("<b> Titre cd </b>") },
{ _("<b> Recto % </b>") },
{ _("<b> Verso % </b>") },
{ _("<b> Emplacement des images Web </b>") },
{ _(" Image ") },
{ _("<b> Titre </b>") },
{ _("<b> Pied de page </b>") },
{ _(" Titre ") },
{ _("<b> Recto </b>") },
{ _("<b> Verso </b>") },
{ _("<b> Relier les champs </b>") },
{ _("de la liste") },
{ _("<b> Numerotation </b>") },
{ _("Titres cd") },
{ _("<b> Importation </b>") },
{ _("<b> Texte pochette </b>") },
{ _(" Texte ") },
{ _(" Pochette ") },
{ _("Nice") },
{ _(" <b>Priorite systeme</b> ") },
{ _("<i><b>Indiquez</b> ici le dossier sur votre systeme qui servira de lieu\nde stockage provisoire pendant les differentes conversions.</i>\n") },
{ _(" <b>Dossier provisoire des conversions</b> ") },
{ _("Activer l'enregistrement du journal") },
{ _("Supprimer le journal") },
{ _("\n<i>Le journal de log pourra etre lu avec votre editeur favori</i>") },
{ _(" <b>Journal de logs</b> ") },
{ _(" General ") },
{ _("cdparanoia") },
{ _("ioctl") },
{ _("<b> Lecture base cd-audio avec:  </b>") },
{ _("cdparanoia") },
{ _("cdda2wav / icedax") },
{ _("cdparanoia mode expert") },
{ _("<b> Extraction cd-audio avec:  </b>") },
{ _("<b>HomePage</b>") },
{ _("<b>ManPage</b>  ") },
{ _(" <b>Web cdparanoia</b> ") },
{ _("<b>%a</b>  -  artiste                                   <b>%b</b>  -  titre de l'album        <b>%c</b>  -  numero de la piste\n<b>%d</b>  -  titre de la chanson                <b>%e</b>  -  annee                     <b>%g</b>  -  genre") },
{ _(" <b>Dossier de stockage</b> ") },
{ _(" CD  ") },
{ _("ABR / CBR / VBR / VBR-NEW") },
{ _("Debit") },
{ _("Mode") },
{ _(" <b> Lame (fichier mp3): </b> ") },
{ _("Par defaut") },
{ _(" <b>Options LAME</b> ") },
{ _("<b>Site officiel</b>") },
{ _("<b>Wiki mp3</b>   ") },
{ _("<b>Wiki  </b>            ") },
{ _("<b>ManPage</b>     ") },
{ _(" <b>Web Lame</b> ") },
{ _("<b>[</b>") },
{ _("<b>string option interne</b>") },
{ _("<b>]</b>") },
{ _("<b> Options experts, definies par l'utilisateur - lame (wav -> mp3) </b>") },
{ _(" Mp3 ") },
{ _(" Debit") },
{ _(" Mode flux (streaming)") },
{ _(" Mode") },
{ _("<b> Oggenc  (fichier ogg): </b> ") },
{ _("Par defaut") },
{ _(" <b>Options OGGENC</b> ") },
{ _("<b>Wiki</b>             ") },
{ _("<b>ManPage</b>") },
{ _(" <b>Web Oggenc</b> ") },
{ _("<b>[</b>") },
{ _("<b>string option interne</b>") },
{ _("<b>]</b>") },
{ _("<b> Options experts, definies par l'utilisateur - oggenc (wav -> ogg) </b>") },
{ _(" Oggenc ") },
{ _("Taux de compression") },
{ _("<b> Flac  (fichier flac): </b> ") },
{ _("Par defaut") },
{ _(" <b>Options FLAC</b> ") },
{ _("<b>Site officiel</b>") },
{ _("<b>Framasoft</b> ") },
{ _("<b>ManPage</b>   ") },
{ _(" <b>Web Flac</b> ") },
{ _("<b>[</b>") },
{ _("<b>string option interne</b>") },
{ _("<b>]</b>") },
{ _("<b> Options experts, definies par l'utilisateur - flac (wav -> flac) </b>") },
{ _(" Flac ") },
{ _(" Qualite") },
{ _("<b> Mac (fichier ape): </b> ") },
{ _("Par defaut") },
{ _(" <b>Options MAC</b> ") },
{ _("<b>Wiki</b>") },
{ _(" <b>Web Mac</b> ") },
{ _("<b>[</b>") },
{ _("<b>string option interne</b>") },
{ _("<b>]</b>") },
{ _("<b> Options experts, definies par l'utilisateur - mac (wav -> ape) </b>") },
{ _(" Mac ") },
{ _("Compression") },
{ _("Son") },
{ _("Mode hybride") },
{ _("Fichier de correction") },
{ _("Compression maximum") },
{ _("Signature MD5") },
{ _("Extra encode processing") },
{ _("<b> WavPack  (fichier wv): </b> ") },
{ _("Par defaut") },
{ _(" <b>Options WAVPACK</b> ") },
{ _("<b>Wiki</b>         ") },
{ _("<b>ManPage</b>") },
{ _(" <b>Web Wavpack</b> ") },
{ _("<b>[</b>") },
{ _("<b>string option interne</b>") },
{ _("<b>]</b>") },
{ _("<b> Options experts, definies par l'utilisateur - wavpack (wav -> wv) </b>") },
{ _(" Wavpack ") },
{ _("<b> MusePack  (fichier mpc): </b> ") },
{ _("Par defaut") },
{ _(" <b>Options MUSEPACK</b> ") },
{ _("<b>Site officiel</b>") },
{ _("<b>Framasoft</b> ") },
{ _(" <b>Web Musepack</b> ") },
{ _("<b>[</b>") },
{ _("<b>string option interne</b>") },
{ _("<b>]</b>") },
{ _("<b> Options experts, definies par l'utilisateur - musepack (wav -> mpc) </b>") },
{ _(" Musepack ") },
{ _(" Conteneur") },
{ _("  VBR / ABR") },
{ _(" Qualite VBR / Debit ABR") },
{ _("<b> Faac  (fichier .m4a): </b> ") },
{ _("Par defaut") },
{ _(" <b>Options FAAC</b> ") },
{ _("<b>Site officiel</b> ") },
{ _("<b>Web Info</b> ") },
{ _("<b>ManPage</b>") },
{ _(" <b>Web Faac</b> ") },
{ _("<b>[</b>") },
{ _("<b>string option interne</b>") },
{ _("<b>]</b>") },
{ _("<b> Options experts, definies par l'utilisateur - faac (wav -> m4a) </b>") },
{ _(" Faac ") },
{ _(" Mono:    Qualite en kbit/s") },
{ _(" Stereo:  Qualite en kbit/s") },
{ _("<b> AacplusEnc  (fichier .aac): </b> ") },
{ _("Par defaut") },
{ _(" <b>Options AacPlusEnc</b> ") },
{ _("<b>Site officiel</b> ") },
{ _("<b>Web Info</b> ") },
{ _("<b>ManPage</b>") },
{ _(" <b>Web AacPlusEnc</b> ") },
{ _(" AacplusEnc ") },
{ _("Artiste") },
{ _("Titre") },
{ _("Album") },
{ _("Numero") },
{ _("Genre") },
{ _("Annee") },
{ _("Commentaire") },
{ _("<b> Exportation de </b>") },
{ _(" Tags ") },
{ _(" Preferences  ") },
{ _("SCAN") },
{ _("<b> Installation </b>") },
{ _("<b> Votre systeme utilise ... </b>") },
{ _("\n<b><i>Pour installer les programmes externes requis,\nveuillez utiliser l'installateur de votre distribution Gnu/Linux.</i></b>\n") },
{ _("xcfa_install_all  ecrit en Perl vous sera utile en ligne de commande pour une installation complementaire.") },
{ _("<b> Informations </b>") },
{ _(" Application externes ") },
{ _("<i>parametres:</i>") },
{ _("<b>Navigateur</b>") },
{ _("<i>parametres:</i>") },
{ _("<b>Lecteurs audio</b>") },
{ _(" Navigateurs / Lecteurs audio ") },
{ _(" Applications externes ") },
{ _("Scan en cours ...") },
{ _("<b>Scan du support en cours ...</b>") },
{ _("Detail extraction mode expert") },
{ _("gtk-cancel") },
{ _("Modification des champs") },
{ _("\n<b>Modification des champs</b>\n") },
{ _("Titre") },
{ _("Play") },
{ _("Temps") },
{ _("Format") },
{ _("Choix") },
{ _("Normalise") },
{ _("Nom") },
{ _("<b> Visibilite </b>") },
{ _("Nom a gauche") },
{ _("Nom au centre") },
{ _("Nom a droite") },
{ _("DVD") },
{ _("Play") },
{ _("Wav") },
{ _("Flac") },
{ _("Ape") },
{ _("Wavpack") },
{ _("Ogg") },
{ _("M4a") },
{ _("Aac") },
{ _("Musepack") },
{ _("Mp3") },
{ _("Num") },
{ _("Time") },
{ _("Normalise") },
{ _("Nom") },
{ _("<b> Visibilite </b>") },
{ _("Nom a gauche") },
{ _("Nom au centre") },
{ _("Nom a droite") },
{ _("CD") },
{ _("Play") },
{ _("Trash") },
{ _("Type") },
{ _("Wav") },
{ _("Flac") },
{ _("Ape") },
{ _("Wavpack") },
{ _("Ogg") },
{ _("M4a") },
{ _("Aac") },
{ _("Musepack") },
{ _("Mp3") },
{ _("Time") },
{ _("Normalise") },
{ _("Replaygain") },
{ _("Nom") },
{ _("<b> Visibilite </b>") },
{ _("Nom a gauche") },
{ _("Nom au centre") },
{ _("Nom a droite") },
{ _("CONVERSIONS") },
{ _("Hertz") },
{ _("New Hertz") },
{ _("Voie") },
{ _("New Voie") },
{ _("Bits") },
{ _("New Bits") },
{ _("Nom") },
{ _("<b> Visibilite </b>") },
{ _("Nom a gauche") },
{ _("Nom au centre") },
{ _("Nom a droite") },
{ _("WAV") },
{ _("Type") },
{ _("Bitrate") },
{ _("New Bitrate") },
{ _("Size") },
{ _("Time") },
{ _("Nom") },
{ _("<b> Visibilite </b>") },
{ _("Nom a gauche") },
{ _("Nom au centre") },
{ _("Nom a droite") },
{ _("MP3-OGG") },
{ _("Type") },
{ _("Time") },
{ _("Nom") },
{ _("<b> Visibilite </b>") },
{ _("Nom a gauche") },
{ _("Nom au centre") },
{ _("Nom a droite") },
{ _("TAGS") },
{ _("Selection globale") },
{ _("Deselection globale") },
{ _("Retour") },
{ _("gtk-quit") },
{ _("gtk-media-play") },
{ _("gtk-media-pause") },
{ _("About X Convert File Audio") },
{ _("<b>Author</b>") },
{ _(" Informations ") },
{ _(" Machine ") },
{ _("\n<b>Traduction Italienne</b>") },
{ _("\n<b>Codeur pages Web</b>") },
{ _("\n<b>ElementSpeak pour Xcfa</b>  ") },
{ _("\n<b>Codeur Xcfa</b>") },
{ _("\n<b>Traduction Allemande</b>") },
{ _("<b>Traduction Anglaise</b>\n\n\n") },
{ _("\n<b>Graphisme</b>\n") },
{ _("<b>Ingenieurs du son</b>\n") },
{ _("\n\n<b>Pages  a  visiter</b>\n") },
{ _("Debian Multimedia") },
{ _("Je suis libre") },
{ _("Bishop's page") },
{ _("Ekd (EnKoDeur-Mixeur)") },
{ _("Framasoft") },
{ _("Tuxfamily") },
{ _("Audioptimisation by Dzef") },
{ _("La Linuxerie") },
{ _("Road2Mayotte") },
{ _("Frugalware") },
{ _("Linux On The Root") },
{ _("\n<b>Forum</b>\n") },
{ _("Forum Xcfa") },
{ _("XCFA  LinuxForen.de") },
{ _("XCFA  Vorstellung ") },
{ _("\n<b>Documentation</b>\n") },
{ _("Xcfa sur Linux On The Root") },
{ _("La normalisation expliquee par Dzef") },
{ _("Ogg Vorbis explique par Shankarius") },
{ _("Doc Xcfa par Patachon") },
{ _("Wiki Xcfa par Shankarius") },
{ _(" Contributions ") },
{ _(" License ") },
{ _("OK") },
{ _("gtk-quit") }

};



	if (*trans [ 0 ] . string);
}











